;; Here we define the places in our world...
;;------------------------------------------

;; named-objects now get short-desc in constructor
;; optional long-desc added via 'add-long-desc message

(define Purnell      (make-place "Purnell Hall" "There's a bunch of miscellaneous business-type stuff."))
(ask Purnell 'add-long-desc "The home of several business related academic departments. Until and unless the world gets more detailed, the lecture halls and other classrooms are inaccessible, and the only exit is east and goes straight to Smith, skipping the outdoor area entirely.")
(define dungeon      (make-place "Dungeon" "It's ugly and it smells bad."))
(ask dungeon 'add-long-desc "There's a kind of surreal quality to this place, as if it's not really here. Or maybe it's just the foul stench interfering with perception. In any case, it's not very pretty.")
(define SmithLobby   (make-place "Smith Lobby" "The center of Smith Hall."))
(ask SmithLobby 'add-long-desc "Normally a crossroads of students due to its fairly cental location, second floor classrooms, three large lecture halls, snack bar, and basement computer lab, the lobby is unusually quiet at present. Perhaps it's because there are only four beings in the world, and one of them is a troll?")
(define smith-lab (make-place "Smith Computer Lab" "Despite the name, there are no computers here."))
(ask smith-lab 'add-long-desc "This is the busiest computer lab on campus due to its central location, wide variety of resources, and help center. However, someone seems to have taken all but one of the computers.")
(define generic-computer (make-named-object '(generic computer) "generic computer" ))
(ask generic-computer 'add-long-desc "It's a generic older computer, with an empty 5 1/4\" floppy drive and a faded sticker boasting of the great speed of an 80386 processor combined with a whopping 4 megs of RAM.")
(ask smith-lab 'add-thing generic-computer)  ;; decorative
(define Kirkbride    (make-place "Kirkbride Hall" "What a peculiar building."))
(ask Kirkbride 'add-long-desc "Kirkbride, a series of lecture halls with exterior doors and only auxiliary passages indoors, appears to be an experiment in architectural variation. Unfortunately, it's an experiment gone wrong. Access to the rooms from the outside is only by way of two passages with openings to the rest of campus at only two locations, placed as inconveniently as possible, with the stairs to the second floor walkway particularly awkwardly placed. The only locations with convenient access are Ewing Hall to the west and the courtyard-ish thing with the bike racks to the east. Travel north is particularly poor.")
(define terry-office (make-place "Terry's Office" "Shouldn't there be a hallway around here?"))
(ask terry-office 'add-long-desc "This is Terry's office. It's somewhere upstairs in Smith Hall. That's about it.")
(define errol-office (make-place "Errol's Office" "Do you occupy the office, or does it contain you?"))
(ask errol-office 'add-long-desc "This is Errol's office somewhere upstairs in Smith Hall. Like most offices, it's rather small, but doesn't need much space to do its job.")
(define gore-hall (make-place "Gore Hall" "Fairly clean, modern, and aesthetic."))
(ask gore-hall 'add-long-desc "One of the nicer buildings on campus, Gore Hall has numerous high-tech classrooms, several with comfy chairs, and a central area that spans all three floors. In the center, a fancy compass design decorates the floor, while a large skylight above adds natural lighting. The building has exits in each of the cardinal directions (or it would if there were destinations...)")
(define dormitory    (make-place "Dormitories" "Cramped and smelly."))
(ask dormitory 'add-long-desc "Without going into too much detail, there's a reason dorms are cheaper than apartments...")
(define heaven       (make-place "Heaven" "...or is it?" ))	; The point of no return
(ask heaven 'add-long-desc "Actally, it's more of a holding cell for people that get eaten, since there's no system in place to actually remove a person or to revive them. But whatever. There's nothing here. Really.")

;; One-way paths connect individual places in the world.
;;------------------------------------------------------

(define (can-go from direction to)
  (ask from 'add-neighbor direction to))

(define (can-go-both-ways from direction reverse-direction to)
  (can-go from direction to)
  (can-go to reverse-direction from))

(can-go-both-ways SmithLobby   'down  'up    smith-lab)
(can-go-both-ways SmithLobby   'north 'south Kirkbride)
(can-go-both-ways SmithLobby   'west  'east  Purnell)
(can-go-both-ways SmithLobby   'up    'down  errol-office)
(can-go-both-ways errol-office 'north 'south terry-office)
(can-go-both-ways SmithLobby   'east  'west  gore-hall)
(can-go-both-ways gore-hall    'south 'north dormitory)

(can-go dungeon  'up  smith-lab)